
!PRAddCommand methodsFor: '*Pier-SW2-Model-Logging' stamp: 'JCB 2/13/2009 14:35'!
printForLogOn: aStream 
	"Print a text command that a kernel can execute to perform
	this
	command. "
	aStream nextPutAll: '(PRPathLookup start: (PRKernel instances detect: [:e | e name = ''';
		 nextPutAll: self context kernel name;
		 nextPutAll: ''']) root path: ''/'.
	self structure parents copy removeFirst;
		do: [:page | aStream nextPutAll: page name;
				 nextPut: $/].
	aStream nextPutAll: ''') addChild: (';
		 nextPutAll: self type name;
		 nextPutAll: ' named: ';
		 nextPutAll: self name.
	(self link notNil
			and: [self link hasAlias])
		ifTrue: [aStream nextPutAll: '; title: ';
				 nextPutAll: self link alias;
				 nextPutAll: '; yourself'].
	aStream nextPutAll: ').'! !

!PRLocationCommand methodsFor: '*Pier-SW2-Model-Logging' stamp: 'JCB 2/13/2009 14:37'!
printForLogOn: aStream 
	aStream nextPutAll: '"';
		 nextPutAll: self class label;
		 space;
		 nextPutAll: self name;
		 nextPutAll: ' to /'.
	self target parents copy removeFirst;
		do: [:page | aStream nextPutAll: page name;
				 nextPut: $/].
	aStream nextPut: $"! !

!PREditPageCommandTest methodsFor: '*pier-SW2-Model-Logging' stamp: 'JCB 2/26/2009 21:49'!
testContentsWrittenToFile
	| document stream |
	document := PRPage descriptionDocument
		fromString: '!!Restore from Text
This will be written to a file, it will be needed if a restore must be done.'.
	self command
		write: document
		using: PRPage descriptionDocument.
	self
		shouldnt: [self command execute]
		raise: PRStructureError.
	stream := ReadWriteStream on: (String new: 300).
	self command printForLogOn: stream.
	self assert: ('*!!Restore from Text*' match: stream contents)! !

!PRHistoryPersistency methodsFor: '*Pier-SW2-Model-Logging' stamp: 'JCB 2/13/2009 14:44'!
add: aContext 
	self writeToLogFrom: aContext.
	history addLast: aContext.
	maxHistory isNil
		ifTrue: [^ self].
	[history size <= maxHistory]
		whileFalse: [history removeFirst]! !

!PRHistoryPersistency methodsFor: '*Pier-SW2-Model-Logging' stamp: 'JCB 2/28/2009 22:03'!
writeToLogFrom: aContext 
	| dir file filename |
	filename := ('changes.'
				, (aContext kernel name
						reject: [:c | c = Character space]) , '.log') asLowercase.
	file := nil.
	[((dir := FileDirectory default) fileExists: filename)
		ifTrue: [file := dir oldFileNamed: filename]
		ifFalse: [file := dir newFileNamed: filename].
	file setToEnd; cr; cr; nextPut: $"; nextPutAll: TimeStamp current printString; nextPut: $"; cr.
	aContext command printForLogOn: file]
		ensure: [file isNil
				ifFalse: [file close]]! !

!PUChangeOther methodsFor: '*Pier-SW2-Model-Logging' stamp: 'JCB 2/13/2009 14:42'!
printForLogOn: aStream 
	aStream nextPut: $";
		 nextPutAll: self class label;
		 nextPutAll: ' for /'.
	self structure parents copy removeFirst;
		do: [:page | aStream nextPutAll: page name;
				 nextPut: $/].
	aStream nextPutAll: ' current: ';
		 nextPutAll: self with printString;
		 nextPutAll: ' recursive: ';
		 nextPutAll: self all printString;
		 nextPutAll: ' operator: ';
		 nextPutAll: self operator asString;
		 nextPutAll: ' permissions: ';
		 nextPutAll: self permissions printString.
	aStream nextPut: $"! !

!PRChangeCommand methodsFor: '*Pier-SW2-Model-Logging' stamp: 'JCB 2/26/2009 21:43'!
printForLogOn: aStream 
	aStream nextPutAll: '"Edit page: /'.
	self structure parents copy removeFirst;
		do: [:page | aStream nextPutAll: page name;
				 nextPut: $/].
	self fields
		keysAndValuesDo: [:k :v | (v isString
					and: [k isDescription])
				ifTrue: [aStream cr; tab; nextPutAll: k label; nextPutAll: ': '; nextPutAll: v]
				ifFalse: [aStream cr; tab; nextPutAll: k label; nextPutAll: ': ';
						nextPutAll: (v isNil
								ifTrue: ['nil']
								ifFalse: [(#(true false ) includes: v)
										ifTrue: [v printString]
										ifFalse: [(v isKindOf: MAFileModel)
												ifTrue: [v filename]
												ifFalse: [(v isKindOf: PRFile)
														ifTrue: [v contents]
														ifFalse: [self structure class descriptionDocument toString: self structure document]]]])]].
	aStream nextPut: $"! !

!PROrderCommand methodsFor: '*Pier-SW2-Model-Logging' stamp: 'JCB 2/13/2009 14:37'!
printForLogOn: aStream 
	aStream nextPut: $";
		 nextPutAll: self class label;
		 space;
		 nextPut: $/.
	self structure parents copy removeFirst;
		do: [:page | aStream nextPutAll: page name;
				 nextPut: $/].
	aStream nextPutAll: self structure name;
		 nextPutAll: ' checked: ';
		 nextPutAll: checked printString;
		 nextPutAll: 'New Order: '.
	self structures
		do: [:page | aStream crtab; nextPutAll: page name].
	aStream nextPut: $"! !

!PRRemoveCommand methodsFor: '*Pier-SW2-Model-Logging' stamp: 'JCB 2/13/2009 14:38'!
printForLogOn: aStream 
	aStream nextPut: $";
		 nextPutAll: self class label;
		 space;
		 nextPut: $/.
	self structure parents copy removeFirst;
		do: [:page | aStream nextPutAll: page name;
				 nextPut: $/].
	aStream nextPutAll: self structure name;
		 nextPut: $"! !

!PUChangeGroup methodsFor: '*Pier-SW2-Model-Logging' stamp: 'JCB 2/13/2009 14:42'!
printForLogOn: aStream 
	aStream nextPut: $";
		 nextPutAll: self class label;
		 nextPutAll: ' for /'.
	self structure parents copy removeFirst;
		do: [:page | aStream nextPutAll: page name;
				 nextPut: $/].
	aStream nextPutAll: ' current: ';
		 nextPutAll: self with printString;
		 nextPutAll: ' recursive: ';
		 nextPutAll: self all printString;
		 nextPutAll: ' group: ';
		 nextPutAll: self group name;
		 nextPutAll: ' operator: ';
		 nextPutAll: self operator asString;
		 nextPutAll: ' permissions: ';
		 nextPutAll: self permissions printString.
	aStream nextPut: $"! !

!PUChangeOwner methodsFor: '*Pier-SW2-Model-Logging' stamp: 'JCB 2/13/2009 14:45'!
printForLogOn: aStream 
	aStream nextPut: $";
		 nextPutAll: self class label;
		 nextPutAll: ' for /'.
	self structure parents copy removeFirst;
		do: [:page | aStream nextPutAll: page name;
				 nextPut: $/].
	aStream nextPutAll: ' current: ';
		 nextPutAll: self with printString;
		 nextPutAll: ' recursive: ';
		 nextPutAll: self all printString;
		 nextPutAll: ' Owner: ';
		 nextPutAll: self owner name;
		 nextPutAll: ' operator: ';
		 nextPutAll: self operator asString;
		 nextPutAll: ' permissions: ';
		 nextPutAll: self permissions printString.
	aStream nextPut: $"! !
